﻿<!-- 	@Author: Erik Tute
        @Version: 1.1.0
        @description: .
-->

<!DOCTYPE html>
<html> 
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width">
    <link rel=stylesheet href=style.css>
    <!--    Only use locally stored libraries here. Else slow loading can screw up whole webapp  -->
    <script language=javascript type=text/javascript src="jquery-2.2.0.min.js"></script>
    <script language=javascript type=text/javascript src="jquery-ui.min.js"></script>
    <script language=javascript type=text/javascript src="knockout-3.4.0.js"></script>
    <script language=javascript type=text/javascript src="instructionsVM.js"></script>
    <script language=javascript type=text/javascript src="utils.js"></script>
    <script language=javascript type=text/javascript src="staticData.js"></script>
    <script language=javascript type=text/javascript src="xlsx.full.min.js"></script>
    <script language=javascript type=text/javascript src="jszip.js"></script>
    <title>ETLBuilder</title>
</head>
<body>
    <div class="overlayWindow menu" data-bind="visible: columns().length>0">
        <!--<button data-bind='click: toJSON, enable: columns().length > 0' id="toJSON">To JSON</button>-->
        <div class="flex">
            <button data-bind='click: addStringsToReplace, enable: columns().length > 0'>Add dictionary entry</button>
            &nbsp;
            <!--Add dictionary from Excel Button-->
            <button data-bind='click: openModal, enable: columns().length > 0'>Add dictionary entry from Excel</button>
        </div>
    </div>

    <!--Modal-->
    <div id="myModal" class="modal">
        <div class="modal-content">
            <span class="close" data-bind='click: closeModal'>&times;</span>
            <input type="file" id="fileUpload" />
            <p>
                <small>
                    Please specify the path to the excel file (.xls or .xlsx).<br/>
                    The excel file must contain the column names <strong>StringToReplace</strong> and <strong>StringToReplaceWith</strong>.
                </small>
            </p>
            <button data-bind='click: uploadExcel'>Upload</button>
        </div>
    </div>


    <div class="overlayWindow probableParams" data-bind="visible: probableConditions().length>0">
        <button data-bind='click: clearProbableValues'>Hide</button><br>
        <table class="probableParams">
            <tbody data-bind="foreach: probableConditions">
                <tr class="probableParam">
                    <td data-bind="text: $data, click: $root.changeConditionValue" class="probableParams"></td>
                </tr>
            </tbody>
        </table>
    </div>

    <div class="overlayWindow probableParams" data-bind="visible: probableActions().length>0">
        <button data-bind='click: clearProbableValues'>Hide</button><br>
        <table class="probableParams">
            <tbody data-bind="foreach: probableActions">
                <tr class="probableParam">
                    <td data-bind="text: $data, click: $root.changeActionValue" class="probableParams"></td>
                </tr>
            </tbody>
        </table>
    </div>

    <div class="overlayWindow probableParams" data-bind="visible: probableParams().length>0" title="Probable Parameters">
        <button data-bind='click: clearProbableValues'>Hide</button><br>
        <table class="probableParams">
            <tbody data-bind="foreach: probableParams">
                <tr class="probableParam">
                    <td data-bind="text: $data, click: $root.changeParameterValue" class="probableParams"></td>
                </tr>
            </tbody>
        </table>
    </div>

    <div class="instructions" data-bind="visible: columns().length>0">
        <a href='#' class="add column" data-bind='click: $root.addColumn'>+</a>
        <ul id="columns" class="columns" data-bind="foreach: columns">
            <li class="column">
                For column: <input class="label column" data-bind="value: colName" />
                <a href='#' class="delete" data-bind='click: $root.deleteItem.bind($data, $parent, "columns")'>X</a>
                <ul class="cAndAs" data-bind="foreach: cAndAs">
                    <li class="condition">
                        on condition: <input class="label" data-bind="value: condition, click: $root.editCondition.bind($data, $parent)" />
                        <a href='#' class="delete" data-bind='click: $root.deleteItem.bind($data, $parent, "cAndAs")'>X</a><br>
                        <a href='#' class="add action" data-bind='click: $root.addActionAtBegin'>+</a>
                        <ul class="actions" data-bind="foreach: actions">
                            <li class="action">
                                invoke method:  <input class="label action" data-bind="value: method, click: $root.editAction.bind($data, $parent)" />
                                <a href='#' class="delete" data-bind='click: $root.deleteItem.bind($data, $parent, "actions")'>X</a><br>
                                <a class="action">with parameters:</a>
                                <table class="parameters" data-bind="foreach: parameters">
                                    <tr class="parameter">
                                        <td data-bind="text: parameterName" class="label"></td>
                                        <td style="width:100%">
                                            <a href='#' class="delete" data-bind='click: $root.deleteItem.bind($data, $parent, "parameters")'>X</a>
                                            <input class="label parameter parameterInput" data-bind="value: parameter, click: $root.editParameter.bind($data, $parent)" />
                                        </td>
                                    </tr>
                                </table>
                                <a href='#' class="add parameter" data-bind='click: $root.addParameter'>+</a>
                            </li>
                        </ul>
                        <a href='#' class="add action" data-bind='click: $root.addAction'>+</a>
                    </li>
                </ul>
                <a href='#' class="add condition" data-bind='click: $root.addCondition'>+</a> <a href='#' class="clone column" data-bind='click: $root.cloneColumn'>C</a>
            </li>
        </ul>
    </div>


    <script language="JavaScript">
        $(function () {
            $(".overlayWindow").draggable();
        });

        $(".inputData").focus();
        $(".inputData").select();

        //GUI-Interaktionen

        //Drag and Drop für Parameter-Vorschläge
        $(".probableParams").on("dragstart", ".probableParams", function (e) {
            e.originalEvent.dataTransfer.setData("type", "parameterSuggestion");
            e.originalEvent.dataTransfer.setData("text", $(this).text());
        });
    </script>
</body>
</html>